/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/ 
*/

// viscousBC.H

//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//
// Dan Martin, Fri, Jan 14, 2000

#ifndef _viscousBC_H_
#define _viscousBC_H_

#include <LevelData.H>
#include <FArrayBox.H>
#include "PhysBCUtil.H"
#include "basicVelBC.H"

/// implements boundary conditions on viscous terms themselves
class viscousBC: public basicVelBC
/** since this class just does 0th-order extrapolation for all
    kinds of boundaries at the moment, it's a pretty simple class */
{

public:

  /// constructor
  viscousBC();

  ///
  ~viscousBC();

  /// apply BC's 
  virtual void applyBCs(LevelData<FArrayBox>& a_viscousTerm,
			const ProblemDomain& a_domain, const Real a_dx) const;

  
  ///
  virtual void applyBCs(FArrayBox& a_state, const ProblemDomain& a_domain,
			const Real a_dx) const;


  /// THIS HAS NOT BEEN IMPLEMENTED!
  virtual void applyBCs(FArrayBox& a_state, const ProblemDomain& a_domain,
			const Real a_dx, int a_comp) const;


  /// apply BC's 
  virtual void applyBCs(LevelData<FArrayBox>& a_viscousTerm,
			const Box& a_domain, const Real a_dx) const;

  
  ///
  virtual void applyBCs(FArrayBox& a_state, const Box& a_domain,
			const Real a_dx) const;


  /// THIS HAS NOT BEEN IMPLEMENTED!
  virtual void applyBCs(FArrayBox& a_state, const Box& a_domain,
			const Real a_dx, int a_comp) const;

protected:

};

#endif


